unit U_GetDllForm;

interface

uses
  Windows, Messages, forms, OleCtnrs, DateUtils, SysUtils, ADODB, dxCore,
  ActiveX;

function GetDllForm(App: Tapplication; FormH: hwnd; FormID: integer; Language: integer; WinStyle: integer; GCode: Pchar; GName: Pchar; DataBase: Pchar; Title: PChar; Parameters1: PChar; Parameters2: PChar; Parameters3: PChar; Parameters4: PChar; Parameters5: PChar; Parameters6: PChar; Parameters7: PChar; Parameters8: PChar; Parameters9: PChar; Parameters10: PChar; DataBaseStr: PChar): hwnd; export; stdcall;

function ConnData(): Boolean;

implementation

uses
  U_DataLink, U_KkAndDjList, U_ShaRKListWSQ, U_PBRKList, U_PBRKSHList,
  U_RCCRKList, U_JCCRClist, U_MRJCCRClist, U_CPCKQEList, U_CPCKDJlist,
  U_TSLRList, U_CPDBList;

       /////////////////////////////////////////////////////////////////
      //         功能说明:取Dll中得窗体                              //
     //        参数说明：App>>调用应用程序；                        //
    //                 FormH>>调用窗口句柄 ；                      //
   //                 FormID>>窗口号;                             //
  //                 Language>>语言种类;                         //
 //                 WinStyle>>窗口类型；                        //
/////////////////////////////////////////////////////////////////
var
  frmShaRKListWSQFH: TfrmShaRKListWSQ;
  frmPBRKList: TfrmPBRKList;
  frmPBRKSHList: TfrmPBRKSHList;
  frmRCCRKList: TfrmRCCRKList;
  frmJCCRClist: TfrmJCCRClist;
  frmMRJCCRClist, frmMRJCCRClistCX: TfrmMRJCCRClist;
  frmCPCKQEList: TfrmCPCKQEList;
  frmCPCKDJlist: TfrmCPCKDJlist;
  frmTSLRList: TfrmTSLRList;
  frmCPDBList: TfrmCPDBList;

function GetDllForm(App: Tapplication; FormH: hwnd; FormID: integer; Language: integer; WinStyle: integer; GCode: Pchar; GName: Pchar; DataBase: Pchar; Title: PChar; Parameters1: PChar; Parameters2: PChar; Parameters3: PChar; Parameters4: PChar; Parameters5: PChar; Parameters6: PChar; Parameters7: PChar; Parameters8: PChar; Parameters9: PChar; Parameters10: PChar; DataBaseStr: PChar): hwnd;
var
  i: Integer;
  bFound: Boolean;
  mnewHandle: hwnd;
  mstyle: TFormStyle;     // 0:子窗口; 1：普通窗口
  mstate: TWindowState;
  mborderstyle: TFormBorderStyle;
begin
  mnewHandle := 0;
  DName := PChar(GName);
  DCode := PChar(GCode);
  DdataBase := DataBase;
  DTitCaption := Title;
  DParameters1 := Parameters1;
  DParameters2 := Parameters2;
  DParameters3 := Parameters3;
  DParameters4 := Parameters4;
  DParameters5 := Parameters5;
  DParameters6 := Parameters6;
  DParameters7 := Parameters7;
  DParameters8 := Parameters8;
  DParameters9 := Parameters9;
  DParameters10 := Parameters10;

  MainApplication := App;
  DCurHandle := FormH;
  IsDelphiLanguage := Language;

  Application := TApplication(App);
  DCurHandle := 0;


   //赋值链接字符串
  SetLength(server, 255);
  SetLength(dtbase, 255);
  SetLength(user, 255);
  SetLength(pswd, 255);

  server := '47.100.130.130,7781';
//  server := '.';
  dtbase := 'zhenyongdata';
  user := 'zhenyongsa';
  pswd := 'rightsoft@9101';
//  pswd := 'rightsoft';
  DConString := 'Provider=SQLOLEDB.1;Password=' + pswd + ';Persist Security Info=True;User ID=' + user + ';Initial Catalog=' + dtbase + ';Data Source=' + server;
  DConString := DataBaseStr;
  // DName:='周高祥';
   //DParameters1:='高权限';
   //DParameters3:='1';
  if not ConnData() then
  begin
    result := 0;
    exit;
  end;

   // 定义窗口类型 、状态
  if WinStyle = 0 then
  begin
    mstyle := fsMDIChild;
    mstate := wsMaximized;
    mborderstyle := bsSizeable;
  end
  else
  begin
    mstyle := fsNormal;
    mstate := wsNormal;
    mborderstyle := bsSizeable;
  end;
  /////////////////////
  //调用子模块窗口
  case FormID of
    111:  //纱线发货管理
      begin
        bFound := FALSE;
        for i := (App.MainForm.MDIChildCount - 1) downto 0 do
        begin
          if App.MainForm.MDIChildren[i].Caption = '纱线发货管理' then
          begin
            BringWindowToTop(frmShaRKListWSQFH.Handle);
            bFound := TRUE;
            Break;
          end;
        end;
        if not bFound then
       //if frmBaoGuanListBGZL=nil then
        begin
          frmShaRKListWSQFH := TfrmShaRKListWSQ.Create(application.MainForm);
          with frmShaRKListWSQFH do
          begin
            Title := '纱线发货管理';
            caption := Trim(Title);
            FormStyle := mstyle;
            windowState := mstate;
            BorderStyle := mborderstyle;
           //show;
          end;
        end
        else
          frmShaRKListWSQFH.BringToFront;
       //句柄
        mnewHandle := frmShaRKListWSQFH.Handle;
      end;

    211:  //坯布发货管理
      begin
        bFound := FALSE;
        for i := (App.MainForm.MDIChildCount - 1) downto 0 do
        begin
          if App.MainForm.MDIChildren[i].Caption = '坯布发货管理' then
          begin
            BringWindowToTop(frmPBRKList.Handle);
            bFound := TRUE;
            Break;
          end;
        end;
        if not bFound then
        begin
          frmPBRKList := TfrmPBRKList.Create(application.MainForm);
          with frmPBRKList do
          begin
            Title := '坯布发货管理';
            caption := Trim(Title);
            FormStyle := mstyle;
            windowState := mstate;
            BorderStyle := mborderstyle;
           //show;
          end;
        end
        else
          frmPBRKList.BringToFront;
       //句柄
        mnewHandle := frmPBRKList.Handle;
      end;

    221:  //坯布仓库确认
      begin
        bFound := FALSE;
        for i := (App.MainForm.MDIChildCount - 1) downto 0 do
        begin
          if App.MainForm.MDIChildren[i].Caption = '坯布仓库确认' then
          begin
            BringWindowToTop(frmPBRKSHList.Handle);
            bFound := TRUE;
            Break;
          end;
        end;
        if not bFound then
        begin
          frmPBRKSHList := TfrmPBRKSHList.Create(application.MainForm);
          with frmPBRKSHList do
          begin
            Title := '坯布仓库确认';
            caption := Trim(Title);
            FormStyle := mstyle;
            windowState := mstate;
            BorderStyle := mborderstyle;
           //show;
          end;
        end
        else
          frmPBRKSHList.BringToFront;
       //句柄
        mnewHandle := frmPBRKSHList.Handle;
      end;
    231:  //成品仓库确认
      begin
        bFound := FALSE;
        for i := (App.MainForm.MDIChildCount - 1) downto 0 do
        begin
          if App.MainForm.MDIChildren[i].Caption = '成品仓库确认' then
          begin
            BringWindowToTop(frmCPCKQEList.Handle);
            bFound := TRUE;
            Break;
          end;
        end;
        if not bFound then
        begin
          frmCPCKQEList := TfrmCPCKQEList.Create(application.MainForm);
          with frmCPCKQEList do
          begin
            Title := '成品仓库确认';
            caption := Trim(Title);
            FormStyle := mstyle;
            windowState := mstate;
            BorderStyle := mborderstyle;
           //show;
          end;
        end
        else
          frmCPCKQEList.BringToFront;
       //句柄
        mnewHandle := frmCPCKQEList.Handle;
      end;
    241:  //染厂调拨查询
      begin
        bFound := FALSE;
        for i := (App.MainForm.MDIChildCount - 1) downto 0 do
        begin
          if App.MainForm.MDIChildren[i].Caption = '染厂调拨查询' then
          begin
            BringWindowToTop(frmCPDBList.Handle);
            bFound := TRUE;
            Break;
          end;
        end;
        if not bFound then
        begin
          frmCPDBList := TfrmCPDBList.Create(application.MainForm);
          with frmCPDBList do
          begin
            Title := '染厂调拨查询';
            caption := Trim(Title);
            FormStyle := mstyle;
            windowState := mstate;
            BorderStyle := mborderstyle;
           //show;
          end;
        end
        else
          frmCPDBList.BringToFront;
       //句柄
        mnewHandle := frmCPDBList.Handle;
      end;
    311:  //染厂出入库查询
      begin
        bFound := FALSE;
        for i := (App.MainForm.MDIChildCount - 1) downto 0 do
        begin
          if App.MainForm.MDIChildren[i].Caption = '染厂出入库查询' then
          begin
            BringWindowToTop(frmRCCRKList.Handle);
            bFound := TRUE;
            Break;
          end;
        end;
        if not bFound then
        begin
          frmRCCRKList := TfrmRCCRKList.Create(application.MainForm);
          with frmRCCRKList do
          begin
            Title := '染厂出入库查询';
            caption := Trim(Title);
            FormStyle := mstyle;
            windowState := mstate;
            BorderStyle := mborderstyle;
           //show;
          end;
        end
        else
          frmRCCRKList.BringToFront;
       //句柄
        mnewHandle := frmRCCRKList.Handle;
      end;

    411:  //染厂进出存
      begin
        bFound := FALSE;
        for i := (App.MainForm.MDIChildCount - 1) downto 0 do
        begin
          if App.MainForm.MDIChildren[i].Caption = '染厂进出存' then
          begin
            BringWindowToTop(frmJCCRClist.Handle);
            bFound := TRUE;
            Break;
          end;
        end;
        if not bFound then
        begin
          frmJCCRClist := TfrmJCCRClist.Create(application.MainForm);
          with frmJCCRClist do
          begin
            Title := '染厂进出存';
            caption := Trim(Title);
            FormStyle := mstyle;
            windowState := mstate;
            BorderStyle := mborderstyle;
           //show;
          end;
        end
        else
          frmJCCRClist.BringToFront;
       //句柄
        mnewHandle := frmJCCRClist.Handle;
      end;
    412:  //染整品进出存
      begin
        bFound := FALSE;
        for i := (App.MainForm.MDIChildCount - 1) downto 0 do
        begin
          if App.MainForm.MDIChildren[i].Caption = '染整品进出存' then
          begin
            BringWindowToTop(frmMRJCCRClist.Handle);
            bFound := TRUE;
            Break;
          end;
        end;
        if not bFound then
        begin
          frmMRJCCRClist := TfrmMRJCCRClist.Create(application.MainForm);
          with frmMRJCCRClist do
          begin
            Title := '染整品进出存';
            canshu1 := '管理';
            caption := Trim(Title);
            FormStyle := mstyle;
            windowState := mstate;
            BorderStyle := mborderstyle;
           //show;
          end;
        end
        else
          frmMRJCCRClist.BringToFront;
       //句柄
        mnewHandle := frmMRJCCRClist.Handle;
      end;
    413:  //染整品进出存查询
      begin
        bFound := FALSE;
        for i := (App.MainForm.MDIChildCount - 1) downto 0 do
        begin
          if App.MainForm.MDIChildren[i].Caption = '染整品进出存查询' then
          begin
            BringWindowToTop(frmMRJCCRClistCX.Handle);
            bFound := TRUE;
            Break;
          end;
        end;
        if not bFound then
        begin
          frmMRJCCRClistCX := TfrmMRJCCRClist.Create(application.MainForm);
          with frmMRJCCRClistCX do
          begin
            Title := '染整品进出存查询';
            caption := Trim(Title);
            FormStyle := mstyle;
            windowState := mstate;
            BorderStyle := mborderstyle;
           //show;
          end;
        end
        else
          frmMRJCCRClistCX.BringToFront;
       //句柄
        mnewHandle := frmMRJCCRClistCX.Handle;
      end;
    511:  //成品出库查询
      begin
        bFound := FALSE;
        for i := (App.MainForm.MDIChildCount - 1) downto 0 do
        begin
          if App.MainForm.MDIChildren[i].Caption = '成品出库查询' then
          begin
            BringWindowToTop(frmCPCKDJlist.Handle);
            bFound := TRUE;
            Break;
          end;
        end;
        if not bFound then
        begin
          frmCPCKDJlist := TfrmCPCKDJlist.Create(application.MainForm);
          with frmCPCKDJlist do
          begin
            Title := '成品出库查询';
            caption := Trim(Title);
            FormStyle := mstyle;
            windowState := mstate;
            BorderStyle := mborderstyle;
           //show;
          end;
        end
        else
          frmCPCKDJlist.BringToFront;
       //句柄
        mnewHandle := frmCPCKDJlist.Handle;
      end;

    551:  //特殊任务查询
      begin
        bFound := FALSE;
        for i := (App.MainForm.MDIChildCount - 1) downto 0 do
        begin
          if App.MainForm.MDIChildren[i].Caption = '特殊任务查询' then
          begin
            BringWindowToTop(frmTSLRList.Handle);
            bFound := TRUE;
            Break;
          end;
        end;
        if not bFound then
        begin
          frmTSLRList := TfrmTSLRList.Create(application.MainForm);
          with frmTSLRList do
          begin
            Title := '特殊任务查询';
            caption := Trim(Title);
            FormStyle := mstyle;
            windowState := mstate;
            BorderStyle := mborderstyle;
           //show;
          end;
        end
        else
          frmTSLRList.BringToFront;
       //句柄
        mnewHandle := frmTSLRList.Handle;
      end;

  end;

  Result := mnewHandle;
end;
//===========================================================
  //建立数据库连接池
//===========================================================

function ConnData(): Boolean;
begin
  if not Assigned(DataLink_MobileTrack) then
    DataLink_MobileTrack := TDataLink_MobileTrack.Create(Application);
  try
    with DataLink_MobileTrack.ADOLink do
    begin
      //if not Connected then
      begin
        Connected := false;
        ConnectionString := DConString;
        LoginPrompt := false;
        Connected := true;
      end;
    end;
    Result := true;
  except
    Result := false;
    application.MessageBox('数据库连接失败！', '错误', mb_Ok + MB_ICONERROR);
  end;

end;

initialization
  CoInitialize(nil);
  dxUnitsLoader.Initialize;


finalization
  DataLink_MobileTrack.Free;
  application := NewDllApp;
  dxUnitsLoader.Finalize;

end.

